%define name gambas
%define version 1.0.18
%define release %mkrel 2

Name: %{name}
Summary: Free and complete IDE based on a basic interpreter with object extensions
Version: %{version}
Release: %{release}
License: GPL
Group: Development/Other
URL: http://gambas.sourceforge.net/
Source0: http://gambas.sourceforge.net/%{name}-%version.tar.bz2
# fwang: Patch0,1,2,3,4 from Fedora
Patch0:         gambas-1.0.9-gcc4.patch
Patch1:         gambas-1.0.6-dont-make-links.patch
Patch2:         gambas-1.0.6-noopt.patch
Patch3:         gambas-1.0.13-gettextfix.patch
Patch4:         gambas-1.0.16-64bit.patch
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildRequires: bzip2-devel
BuildRequires: gettext-devel
BuildRequires: kdelibs-devel
BuildRequires: libcurl-devel
BuildRequires: libgamin-devel
BuildRequires: libgettextmisc
BuildRequires: libopenssl-devel
BuildRequires: libSDL-devel
BuildRequires: libsmpeg-devel
BuildRequires: libsqlite-devel
BuildRequires: libvorbis-devel
BuildRequires: mysql-devel
BuildRequires: postgresql-devel
BuildRequires: SDL_mixer-devel
BuildRequires: acl-devel
ExclusiveArch: %{ix86}

%description
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic(tm) (but it is NOT a clone!). 
With Gambas, you can quickly design your program GUI, access MySQL or
PostgreSQL databases, control KDE applications with DCOP, translate
your program into many languages, create network applications easily,
build RPMs of your apps automatically, and so on...

%prep
%setup -q 
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build

# Gambas can't deal with -Wp,-D_FORTIFY_SOURCE=2
#CFLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//g'`

%configure --enable-conv=no \
	--with-qt-includes=%qt3include --with-qt-libraries=%qt3lib \
	--with-gettext-libraries=%_libdir --with-bzlib2-libraries=%_libdir \
	--with-intl-libraries=%_libdir \
	--with-sqlite-libraries=%_libdir --with-kde-libraries=%_libdir \
	--with-net-libraries=%_libdir --with-curl-libraries=%_libdir \
	--with-postgresql-libraries=%_libdir --with-mysql-libraries=%_libdir \
	--with-sdl-libraries=%_libdir --with-libxml-libraries=%_libdir

%make

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_miconsdir}
install -d $RPM_BUILD_ROOT/%{_iconsdir}
install -d $RPM_BUILD_ROOT/%{_liconsdir}
install -m644 app/gambas/img/logo/gambas-16x16.png $RPM_BUILD_ROOT/%{_miconsdir}/gambas.png
install -m644 app/gambas/img/logo/gambas-32x32.png $RPM_BUILD_ROOT/%{_iconsdir}/gambas.png
install -m644 app/gambas/img/logo/gambas-48x48.png $RPM_BUILD_ROOT/%{_liconsdir}/gambas.png

# fwang: Remove icon path at the moment
sed -i -e 's|Icon=.*|Icon=gambas.png|' debian/%{name}.desktop
desktop-file-install --vendor="" \
  --remove-category="Application" \
  --add-category="GTK" \
  --add-category="IDE" \
  --add-category="X-MandrivaLinux-MoreApplications-Development-DevelopmentEnvironments" \
  --remove-key="GenericName" \
  --remove-key="Comment" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications debian/%{name}.desktop

%makeinstall ROOT=$RPM_BUILD_ROOT

#-----------------------------------------------------------------------------

%package runtime
Summary: The Gambas runtime
Group: Development/Other

%description runtime
This package includes the Gambas interpreter needed to run Gambas applications.

%files runtime
%defattr(-, root, root, 0755)
%doc README AUTHORS COPYING INSTALL README.REDHAT README.DEBIAN TODO
%{_bindir}/gbi
%{_bindir}/gbx
%{_libdir}/gambas/lib.gb.component
%{_datadir}/gambas/info/gb.info
%{_datadir}/gambas/info/gb.list

#-----------------------------------------------------------------------------

%package ide
Summary: The Gambas IDE
Group: Development/Other
Requires: gambas-runtime = %{version}
Requires: gambas-gb-compress = %{version}
Requires: gambas-gb-db = %{version}
Requires: gambas-gb-db-mysql = %{version}
Requires: gambas-gb-db-postgresql = %{version}
Requires: gambas-gb-db-sqlite = %{version}
Requires: gambas-gb-eval = %{version}
Requires: gambas-gb-net = %{version}
Requires: gambas-gb-net-curl = %{version}
Requires: gambas-gb-qt = %{version}
Requires: gambas-gb-qt-editor = %{version}
Requires: gambas-gb-qt-ext = %{version}
Requires: gambas-gb-qt-kde = %{version}
Requires: gambas-gb-qt-kde-html = %{version}
Requires: gambas-gb-sdl = %{version}
Requires: gambas-gb-vb = %{version}
Requires: gambas-gb-xml = %{version}
Requires: gambas-gb-debug = %{version}

%description ide
This package includes the complete Gambas Development Environment, with the
database manager, the help files, and all components.

%post ide
%{update_menus}

%postun ide
%{clean_menus}

%files ide
%defattr(-, root, root, 0755)
%{_bindir}/gambas
%{_bindir}/gbc
%{_bindir}/gba
%{_bindir}/gambas-database-manager
%{_datadir}/applications/%{name}.desktop
%{_datadir}/gambas/help
%{_datadir}/gambas/examples
%{_miconsdir}/gambas.png
%{_iconsdir}/gambas.png
%{_liconsdir}/gambas.png

#-----------------------------------------------------------------------------

%package gb-compress
Summary: The Gambas compression component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-compress
This component allows you to compress/uncompress data or files with
the bzip2 and zip algorithms.

%files gb-compress
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.compress.*
%{_datadir}/gambas/info/gb.compress.*

#-----------------------------------------------------------------------------

%package gb-db
Summary: The Gambas database component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-db
This component allows you to access many databases management systems,
provided that you install the needed driver packages.

%files gb-db
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.db.la
%{_libdir}/gambas/lib.gb.db.so*
%{_libdir}/gambas/lib.gb.db.component
%{_datadir}/gambas/info/gb.db.info
%{_datadir}/gambas/info/gb.db.list

#-----------------------------------------------------------------------------

%package gb-db-mysql
Summary: The MySQL driver for the Gambas database component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-db = %{version}

%description gb-db-mysql
This component allows you to access MySQL databases.

%files gb-db-mysql
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.db.mysql.*

#-----------------------------------------------------------------------------

%package gb-db-postgresql
Summary: The PostgreSQL driver for the Gambas database component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-db = %{version}

%description gb-db-postgresql
This component allows you to access PostgreSQL databases.

%files gb-db-postgresql
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.db.postgresql.*

#-----------------------------------------------------------------------------

%package gb-db-sqlite
Summary: The SQLite driver for the Gambas database component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-db = %{version}

%description gb-db-sqlite
This component allows you to access SQLite databases.

%files gb-db-sqlite
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.db.sqlite.*

#-----------------------------------------------------------------------------

%package gb-debug
Summary: The debugger helper component for the Gambas IDE
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-debug
This component helps the IDE to debug Gambas programs.

%files gb-debug
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.debug.*
%{_datadir}/gambas/info/gb.debug.*

#-----------------------------------------------------------------------------

%package gb-eval
Summary: The Gambas expression evaluator component 
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-eval
This component allows you to evaluate expressions at runtime. 
It is used by the Gambas Eval() function.

%files gb-eval
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.eval.*
%{_datadir}/gambas/info/gb.eval.*

#-----------------------------------------------------------------------------

%package gb-net
Summary: The Gambas networking component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-net
This component allows you to use TCP/IP and UDP sockets, and to access
any serial ports.

%files gb-net
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.net.la
%{_libdir}/gambas/lib.gb.net.so*
%{_libdir}/gambas/lib.gb.net.component
%{_datadir}/gambas/info/gb.net.info
%{_datadir}/gambas/info/gb.net.list

#-----------------------------------------------------------------------------



%package gb-xml
Summary: The Gambas xml component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-xml
This component allows you to use xml.

%files gb-xml
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.xml.libxml.*la
%{_libdir}/gambas/lib.gb.xml.libxml.*so*
%{_libdir}/gambas/lib.gb.xml.libxml.*component
%{_datadir}/gambas/info/gb.xml.libxml.*info
%{_datadir}/gambas/info/gb.xml.libxml.*list

#-----------------------------------------------------------------------------



%package gb-net-curl
Summary: The Gambas advanced networking component
Group: Development/Other
Requires: %{name}-runtime = %{version},,%{name}-gb-net = %{version}

%description gb-net-curl
This component allows your programs to easily become FTP or HTTP clients.

%files gb-net-curl
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.net.curl.la
%{_libdir}/gambas/lib.gb.net.curl.so*
%{_libdir}/gambas/lib.gb.net.curl.component
%{_datadir}/gambas/info/gb.net.curl.info
%{_datadir}/gambas/info/gb.net.curl.list

#-----------------------------------------------------------------------------

%package gb-qt
Summary: The Gambas Qt GUI component
Group: Development/Other
Requires: %{name}-runtime = %{version},libqt-mt.so.3 >= 3.2

%description gb-qt
This package includes the Gambas QT GUI component.

%files gb-qt
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.qt.la
%{_libdir}/gambas/lib.gb.qt.so*
%{_libdir}/gambas/lib.gb.qt.component
%{_datadir}/gambas/info/gb.qt.info
%{_datadir}/gambas/info/gb.qt.list

#-----------------------------------------------------------------------------

%package gb-qt-ext
Summary: The Gambas extended Qt GUI component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-qt = %{version}

%description gb-qt-ext
This component includes somme uncommon QT controls.

%files gb-qt-ext
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.qt.ext.la
%{_libdir}/gambas/lib.gb.qt.ext.so*
%{_libdir}/gambas/lib.gb.qt.ext.component
%{_datadir}/gambas/info/gb.qt.ext.info
%{_datadir}/gambas/info/gb.qt.ext.list

#-----------------------------------------------------------------------------

%package gb-qt-editor
Summary: The Gambas source code editor component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-qt = %{version}

%description gb-qt-editor
This component includes a Gambas source code editor with syntax highlighting.
It is used by the IDE.

%files gb-qt-editor
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.qt.editor.la
%{_libdir}/gambas/lib.gb.qt.editor.so*
%{_libdir}/gambas/lib.gb.qt.editor.component
%{_datadir}/gambas/info/gb.qt.editor.info
%{_datadir}/gambas/info/gb.qt.editor.list

#-----------------------------------------------------------------------------

%package gb-qt-kde
Summary: The Gambas KDE component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-qt = %{version}

%description gb-qt-kde
This component transforms your QT application in a KDE application, and
allows you to pilot any other KDE application with the DCOP protocol.

%files gb-qt-kde
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.qt.kde.la
%{_libdir}/gambas/lib.gb.qt.kde.so*
%{_libdir}/gambas/lib.gb.qt.kde.component
%{_datadir}/gambas/info/gb.qt.kde.info
%{_datadir}/gambas/info/gb.qt.kde.list

#-----------------------------------------------------------------------------

%package gb-qt-kde-html
Summary: The Gambas KHTML component
Group: Development/Other
Requires: %{name}-runtime = %{version},%{name}-gb-qt-kde = %{version}

%description gb-qt-kde-html
This component allows you to use the KHTML Web Browser widget included in KDE

%files gb-qt-kde-html
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.qt.kde.html.la
%{_libdir}/gambas/lib.gb.qt.kde.html.so*
%{_libdir}/gambas/lib.gb.qt.kde.html.component
%{_datadir}/gambas/info/gb.qt.kde.html.info
%{_datadir}/gambas/info/gb.qt.kde.html.list

#-----------------------------------------------------------------------------

%package gb-sdl
Summary: The Gambas SDL component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-sdl
This component use only the sound part of the SDL library. It allows you to
simultaneously play many sounds and a music stored in a file.

%files gb-sdl
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.sdl.la
%{_libdir}/gambas/lib.gb.sdl.so*
%{_libdir}/gambas/lib.gb.sdl.component
%{_datadir}/gambas/info/gb.sdl.info
%{_datadir}/gambas/info/gb.sdl.list

#-----------------------------------------------------------------------------

%package gb-vb
Summary: The Gambas Visual Basic(tm) compatibility component
Group: Development/Other
Requires: %{name}-runtime = %{version}

%description gb-vb
This component aims at including some functions that imitate the behaviour
of Visual Basic(tm) functions. Use it only if you try to port some VB
projects.

%files gb-vb
%defattr(-,root,root)
%{_libdir}/gambas/lib.gb.vb.la
%{_libdir}/gambas/lib.gb.vb.so*
%{_libdir}/gambas/lib.gb.vb.component
%{_datadir}/gambas/info/gb.vb.info
%{_datadir}/gambas/info/gb.vb.list

#-----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT



%changelog
* Sat Jun 16 2007 Gustavo De Nardin <gustavodn@mandriva.com> 1.0.18-2mdv2008.0
+ Revision: 40447
- fixed gambas-ide missing Requires on gambas-gb-debug

* Tue May 29 2007 Funda Wang <fundawang@mandriva.org> 1.0.18-1mdv2008.0
+ Revision: 32354
- New version
- Requires all components
  ix86 instead

* Wed May 23 2007 Funda Wang <fundawang@mandriva.org> 1.0.17-1mdv2008.0
+ Revision: 30021
- i586 Only
- Merge patches from Fedora Core
- sambas only works in i586
- Use hardcode library path
- Use reconf
- Correctly install xdg menu
- Use xdg menu
- New upstream version


* Thu May 04 2006 Jerome Soyer <saispo@mandriva.org> 1.0.16-1mdk
- New release 1.0.16

* Wed Apr 26 2006 Lenny Cartier <lenny@mandriva.com> 1.0.15-2mdk
- rebuild

* Mon Mar 27 2006 Lenny Cartier <lenny@mandriva.com> 1.0.15-1mdk
- 1.0.15

* Thu Feb 09 2006 Lenny Cartier <lenny@mandriva.com> 1.0.14-1mdk
- 1.0.14

* Thu Nov 17 2005 Lenny Cartier <lenny@mandriva.com> 1.0.13-1mdk
- 1.0.13

* Fri Oct 28 2005 Nicolas Lcureuil <neoclust@mandriva.org> 1.0.11-2mdk
- Fix BuildRequires

* Tue Sep 27 2005 Nicolas Lcureuil <neoclust@mandriva.org> 1.0.11-1mdk
- New release 1.0.11
- %%{1}mdk

* Wed Aug 17 2005 Nicolas Lcureuil <neoclust@mandriva.org> 1.0.10-1mdk
- New release 1.0.10

* Wed Jul 20 2005 Lenny Cartier <lenny@mandriva.com> 1.0.9-1mdk
- 1.0.9
- remove patch merged (1.0.9 now compiles with gcc-4 without errors)

* Wed Jul 13 2005 Herton Ronaldo Krzesinski <herton@mandriva.com> 1.0.8-2mdk
- Updated BuildRequires:
  * libSDL_mixer1.2-devel -> SDL_mixer-devel as reported by Per �Xyvind Karls.
  * XFree86-devel -> libxorg-x11-devel.
  * cosmetics.

* Tue Jul 12 2005 Herton Ronaldo Krzesinski <herton@mandriva.com> 1.0.8-1mdk
- New upstream version: 1.0.8.
- Redid gcc4 patch.
- Added missing libopenssl-devel, libSDL_mixer1.2-devel BuildRequires.
- Need to force configure with gettext, otherwise it keeps it disabled
  (I didn't figure out why it was this way).

* Sun May 15 2005 Couriousous <couriousous@mandriva.org> 1.0.6-2mdk
- Fix spec

* Sun May 15 2005 Couriousous <couriousous@mandriva.org> 1.0.6-1mdk
- 1.0.6
- Import & modifiy debian patcp

* Wed Apr 20 2005 Lenny Cartier <lenny@mandriva.com> 1.0.5-1mdk
- 1.0.5

* Tue Feb 01 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 1.0.3-1mdk
- 1.0.3

* Thu Jan 13 2005 Lenny Cartier <lenny@mandrakesoft.com> 1.0.2-2mdk
- really update to 1.0.2

* Thu Jan 13 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 1.0.2-1mdk
- 1.0.2

* Tue Jan 04 2005 Lenny Cartier <lenny@mandrakesoft.com> 1.0.1-1mdk
- 1.0.1

* Mon Dec 20 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 1.0-0.rc5.2mdk
- 1.0-rc5

* Mon Nov 22 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.99-2mdk
- use better spec from Benoit Minisini <gambas@users.sourceforge.net> :
	- Fix modal windows not being modal with QT 3.2.
	- Fix IDE crash when the .gambas directory does not exist.
	- Updated documentation.

* Mon Sep 06 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.99-1mdk
- 0.99

* Wed Aug 25 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.98-1mdk
- 0.98

* Thu Apr 22 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.92a-2mdk
- fix buildrequires

* Thu Apr 22 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.92a-1mdk
- from Rob Kudla <rpm@kudla.org> :
	- version 0.92a

* Sat Apr 03 2004 Rob Kudla <rpm@kudla.org> 0.92-1mdk
- version 0.92

* Sun Mar 14 2004 Rob Kudla <rpm@kudla.org> 0.91-1mdk
- version 0.91

* Thu Feb 26 2004 Rob Kudla <rpm@kudla.org> 0.90-1mdk
- version 0.90

* Thu Feb 12 2004 Rob Kudla <rpm@kudla.org> 0.84a-1mdk
- version 0.84a

* Sat Jan 24 2004 Rob Kudla <rpm@kudla.org> 0.82-1mdk
- new version

* Tue Jan 20 2004 Rob Kudla <rpm@kudla.org> 0.81-2mdk
- fix examples symlink

* Sat Jan 17 2004 Rob Kudla <rpm@kudla.org> 0.81-1mdk
- new version
- fix help symlink

* Tue Jan 13 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.80-3mdk
- same player shoot again

* Tue Jan 13 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.80-2mdk
- fix requires, use explicit lib dependencies.

* Mon Jan 12 2004 Lenny Cartier <lenny@mandrakesoft.com> 0.80-1mdk
- from Rob <mandrake-cooker@kudla.org> :
	- new version

* Sun Dec 21 2003 - rpm@kudla.org
- new version

* Mon Dec 08 2003 - rpm@kudla.org
- new version

* Fri Nov 21 2003 - rpm@kudla.org
- new version
- attempt at further mandrakifying packages

* Sat Oct 25 2003 - rpm@kudla.org
- new version
- Attempt at mandrakifying packages

* Sat Aug 30 2003 - rpm@kudla.org
- new version

* Mon Aug 04 2003 - rpm@kudla.org
- new version

* Tue Jul 15 2003 - rpm@kudla.org
- new version

* Sun Jul 06 2003 - rpm@kudla.org
- new version

* Fri Jun 27 2003 - rpm@kudla.org
- new version
- updated docs (now HTML for help browser)

* Mon Jun 23 2003 - rpm@kudla.org
- new version
- updated docs

* Mon May 12 2003 - rpm@kudla.org
- new version

* Mon May 05 2003 - rpm@kudla.org
- new version

